
// Mark Nickeson
// www.XEngineering.net
// mark@xengineering.net
// Feb 27 2024

const byte numChars = 32;
char receivedChars[numChars];    // This is an array of values between -128 and 127
char tempChars[numChars];        // This is an array of values between -128 and 127
double doubleFromPC;
double double2FromPC;
double VEDirectBatteryVoltage;
double VEDirectBatteryCurrent;
// variables to hold the parsed data
char messageFromPC[numChars];  //// This is an array of values between -128 and 127
char messageFromPC2[numChars];  //// This is an array of values between -128 and 127

boolean newData = false;
int go = 1;

void setup() {
  // Note the format for setting a serial port is as follows: Serial2.begin(baud-rate, protocol, RX pin, TX pin);
  Serial.begin(115200);
  Serial1.begin(19200, SERIAL_8N1, 16, 17); // note the "1"!
}

void loop() {
  recvWithStartEndMarkers();

  if (newData == true) {
    strcpy(tempChars, receivedChars); // received is the "old" string, "temp" is being created as a copy
    parseData();
    newData = false;
    Serial.print("Batt V: ");
    Serial.println(VEDirectBatteryVoltage);
    Serial.print("Batt C: ");
    Serial.println(VEDirectBatteryCurrent);
  }
}

void recvWithStartEndMarkers() {
  static byte ndx = 0;
  char endMarker = '\n';
  char rc;

  while (Serial1.available() > 0 && newData == false) {
    rc = Serial1.read(); // pick up a single character
    if (rc != endMarker) {
      receivedChars[ndx] = rc; // add that single character to a growing string
      ndx++;
      if (ndx >= numChars) {
        ndx = numChars - 1;
      }
    }
    else {
      receivedChars[ndx] = '\0'; // terminate the string when the endMarker is what was read
      ndx = 0;
      newData = true;
    }
  }
}

void parseData() {      // split the data into its parts
  char *strtokIndx;
  strtokIndx = strtok(tempChars, " \t");     // strtokIndx is now the address of the first data field, everything prior to the Tab
  if (*strtokIndx == 'V')
  {
    char*px2 = strtokIndx + 1;
    if (*px2 == '\0')
    {
      strtokIndx = strtok(NULL, " \t"); // this continues where the previous call left off
      doubleFromPC = atof(strtokIndx);
      // Serial.println(doubleFromPC);
      VEDirectBatteryVoltage = doubleFromPC / 1000;
    }
  }

  if (*strtokIndx == 'I')
  {
    char*px3 = strtokIndx + 1;
    if (*px3 == '\0')
    {
      strtokIndx = strtok(NULL, " \t"); // this continues where the previous call left off
      double2FromPC = atof(strtokIndx);
      // Serial.println(doubleFromPC);
      VEDirectBatteryCurrent = double2FromPC / 1000;
    }
  }

}
